document.addEventListener("DOMContentLoaded", function() {


  /**
   * Global variables declaration
   */

  var mainContainer = $(".kw-body"),
      menuToggler = $(".kw-menu-toggle"),
      homepageMenuToggler = $(".kw-action-block--stroke-splash-home"),
      menuItem = $(".kw-main-menu__item"),
      articleHeroHeight = $(".kw-articles__hero").height(),
      popinToggler = $(".kw-js-popin"),
      popinCloseButton = $(".kw-popin__close-button"),
      mediumScreen = window.matchMedia("(min-width: 750px)").matches,
      anchorURL = window.location.hash.substr(1),
      lastScrollTop = 0,
      scrollDelta = 25,
      whiteBlock = $(".kw-simple-text--standalone"),
      aveneFooter = $("#footer"),
      slider;


  /**
   * Scroll reveal
   */

  window.sr = ScrollReveal({reset:true});
  sr.reveal('.kw-scroll-reveal', {duration:500});

  
  /**
   * Menu
   */

  $(menuToggler).on("click", toggleMenu);
  $(homepageMenuToggler).on("click", toggleMenu);
  $(menuItem).on("click", stateMenuItem);
  $(window).on("scroll", stickyMenu);

  function toggleMenu(){
    if (mainContainer.hasClass("menu-active")) {
      mainContainer.removeClass("menu-active");
      $(menuToggler).removeClass("menu-active");
      aveneFooter.removeClass("kw-footer-not-displayed");
      $("body").removeClass("kw-menu-active");
      $("#page").removeClass('kw-page-height-fixed');
      $("html").removeClass('header-sticky');
      $("#header").removeClass('active');
    } else {
      mainContainer.addClass("menu-active");
      $(menuToggler).addClass("menu-active");
      aveneFooter.addClass("kw-footer-not-displayed");
      $("body").addClass("kw-menu-active");
      $("#page").addClass('kw-page-height-fixed');
      // Reset Avene menu
      setTimeout(function(){
        $("html").addClass('header-sticky');
        $("#header").addClass('active');
      }, 500);
      console.log('open menu');
    };
  }

  function stateMenuItem(e){
    var itemIsActive = $(this).hasClass("item-active");
    if (window.matchMedia("(min-width: 1000px)").matches) {
      //Do nothing
    } else {
      if (itemIsActive) {
        //Go to the page
      } else {
        e.preventDefault();
        menuItem.removeClass("item-active");
        $(this).addClass("item-active");
      }
    };
  }

  function stickyMenu(){
    var st = $(this).scrollTop(),
        popinIsOpen = $(".kw-popin").hasClass('is-active');

    if ($("section").hasClass("kw-simple-text--standalone")) {
      console.log('present');
      var whiteBlockTop = whiteBlock.offset().top,
          whiteBlockBottom = whiteBlockTop + whiteBlock.height();
    }
    if (Math.abs(lastScrollTop - st) <= scrollDelta)
    return;
    if (popinIsOpen) {
      $("body").addClass("kw-js-scrolled");
      // Reset Avene menu
      setTimeout(function(){
        $("html").addClass('header-sticky');
        $("#header").addClass('active');
      }, 500);
      console.log('if popin open sticky menu');
      $("#footer").addClass('kw-footer-hidden');
    } else if (st < scrollDelta) {
      // Back to top.
      $("body").removeClass("kw-js-scrolled");      
    } else if (mainContainer.hasClass("menu-active")){
      setTimeout(function(){
        $("html").addClass('header-sticky');
        $("#header").addClass('active');
      }, 500);
      console.log('main container has class menu-active');
    } else {
      // Scrolling to bottom.
      $("body").addClass("kw-js-scrolled");
    }
    lastScrollTop = st;
    // Change menu toggler color when hovering white background.
    if (st + 80 > whiteBlockTop && st + 80 < whiteBlockBottom) {
      menuToggler.addClass("kw-menu-toggle--reverse");
    } else if (menuToggler.hasClass("kw-menu-toggle--reverse") || st + 80 > whiteBlockBottom) {
      menuToggler.removeClass("kw-menu-toggle--reverse");
    };
  }
  

  /**
   * Popin and sliders
   */

  $(popinToggler).on("click", openPopin);
  $(popinCloseButton).on("click", closePopin);
  $(document).keydown(function(e) {
    if (e.keyCode == 27) {
      closePopin();
    }
  });

  function openPopin(e){
    e.preventDefault;
    var popinID = this.dataset.popin,
        targetedPopin = $("#" + popinID),
        popinSlider = $("#" + popinID + " .kw-slider"),
        slickIsInit = $(popinSlider).hasClass("slick-initialized");
    $(targetedPopin).addClass('is-active');
    $("body").addClass('kw-popin-active');
    $("#page").addClass('kw-page-height-fixed');
    // Init Slider.
    if (!slickIsInit) {
      slider = $(popinSlider).slick({
        swipe:true,
        draggable: true,
        dots: true,
        responsive: [
          {
            breakpoint: 750,
            settings: {
              dots: false
            }
          }
        ]
      });
    };
    // Init ranges' tooltips.
    if ($(targetedPopin).find(".kw-shiny-form").length !== 0) {
      $(".kw-shiny-form__range").each(function() {
        setTooltip($(this));
      });
    };
 
    // Set "Perfect-Scrollbar".
    if (mediumScreen) {
      var scrollBlock = document.getElementsByClassName("kw-slider__item-text-scroll");
      for (var i = scrollBlock.length - 1; i >= 0; i--) {
        var ps = new PerfectScrollbar(scrollBlock[i]);
      };
    }
    $("body").addClass("kw-js-scrolled");

    // Reset Avene menu
    setTimeout(function(){
      $("html").addClass('header-sticky');
      $("#header").addClass('active');
    }, 500);
    console.log('open popin');
    $("#footer").addClass('kw-footer-hidden');

    return slider;
  }

  function closePopin(){
    var activePopinID = $(".kw-popin.is-active").attr('id'),
        originPopin = $("[data-popin='" + activePopinID + "']")
        originPosition = originPopin.offset().top - (articleHeroHeight / 2);
    $(".kw-popin.is-active").removeClass("is-active");
    $("#footer").removeClass('kw-footer-hidden');
    $("body").removeClass("kw-popin-active");
    $("html").removeClass("kw-popin-active");
    $("#page").removeClass('kw-page-height-fixed');
    $(".slick-initialized").slick("unslick");
    history.pushState("ferme", document.title, window.location.pathname + window.location.search);
    // Go back to origin position.
    $("body, html").scrollTop(originPosition);
    if ($(".kw-body").hasClass("kw-back-button")) {
      console.log('remove back button');
      $(".kw-body").removeClass("kw-back-button");
    }
  }


  /**
   * Range input interactions & tooltips.
   */

  $(".kw-shiny-form__range").on('input change', function() {
    setTooltip($(this));
  });

  $(".kw-shiny-form__range").focusin(function () {
    slider.slick("slickSetOption", "draggable", false, false);
  }).mouseout(function () {
    slider.slick("slickSetOption", "draggable", true, false);
  });
  $(".kw-shiny-form__range").on('touchstart', function(){
    slider.slick("slickSetOption", "swipe", false, false);
  }).on('touchend', function(){
    slider.slick("slickSetOption", "swipe", true, false);
  });



  function setTooltip(selector){
    var tooltipWrapper = selector.prev(".kw-shiny-form__tooltip"),
        inputWidth = selector.parent(".kw-shiny-form__input-wrapper").width();
        tooltipValue = parseInt(selector.val()),
        tooltipLatValue = 90 - tooltipValue;
        valueContainer = $(tooltipWrapper).children(".kw-shiny-form__tooltip-val"),
        tooltipPositionPercent = (tooltipValue * 100 / selector.attr("max")),
        ratio = tooltipPositionPercent / 100,
        tooltipPositionPx = (tooltipPositionPercent / 100) * inputWidth,
        tooltipLeftPos = (12.5 + tooltipPositionPx) - ratio * 25,
        tooltipIcon = tooltipWrapper.find(".kw-shiny-form__tooltip-danger");
    
    // Set tooltip value.
    if (selector.attr("name") == "lat") {
      $(valueContainer).text(tooltipLatValue);
    } else if (selector.attr("name") == "cover") {
      $(".kw-shiny-form__tooltip-val").removeClass("is-active");
      $("[data-val='" + tooltipValue + "']").addClass("is-active");
    } else {
      $(valueContainer).text(tooltipValue);
    };

    // Set tooltip position.
    $(tooltipWrapper).css('left', 'calc((12.5px + ' + tooltipPositionPercent + '%) - ' + ratio * 25 + 'px)');
    // Set text color and display/hide icon.
    if (selector.attr("name") !== "hour") {
      if (tooltipPositionPercent > 70) {
        $(tooltipWrapper).css('color', '#ff5400');
        tooltipIcon.addClass('is-active');
      } else if (tooltipPositionPercent > 40) {
        $(tooltipWrapper).css('color', '#f4b870');
        tooltipIcon.removeClass('is-active');
      } else if (tooltipPositionPercent > 20) {
        $(tooltipWrapper).css('color', '#92c3c6');
        tooltipIcon.removeClass('is-active');
      } else {
        $(tooltipWrapper).css('color', '#74d8f4');
        tooltipIcon.removeClass('is-active');
      };
    } else {
      if (tooltipPositionPercent > 90) {
        $(tooltipWrapper).css('color', '#74d8f4');
        tooltipIcon.removeClass('is-active');
      } else if (tooltipPositionPercent > 75) {
        $(tooltipWrapper).css('color', '#92c3c6');
        tooltipIcon.removeClass('is-active');
      } else if (tooltipPositionPercent > 60) {
        $(tooltipWrapper).css('color', '#f4b870');
        tooltipIcon.removeClass('is-active');
      } else if (tooltipPositionPercent > 40) {
        $(tooltipWrapper).css('color', '#ff5400');
        tooltipIcon.addClass('is-active');
      } else if (tooltipPositionPercent > 25) {
        $(tooltipWrapper).css('color', '#f4b870');
        tooltipIcon.removeClass('is-active');
      } else if (tooltipPositionPercent > 10) {
        $(tooltipWrapper).css('color', '#92c3c6');
        tooltipIcon.removeClass('is-active');
      } else {
        $(tooltipWrapper).css('color', '#74d8f4');
        tooltipIcon.removeClass('is-active');
      };
    };

  }


  /**
   * "Click-list"
   */

  $(".kw-shiny-form__click-list-item").on('click', function(event) {
    $(".kw-shiny-form__click-list-item").removeClass("kw-click-item-active");
    $(this).addClass("kw-click-item-active");
  });


  /**
   * Smooth Scroll module
   */

  $('.kw-js-smooth-scroll').on("click", smoothScroll);

  function smoothScroll(){
    var page = $(this).attr('href'); // Page cible
    var speed = 750; // Durée de l'animation (en ms)
    var menuHeight = 66;
    $('html, body').animate({ scrollTop: $(page).offset().top - menuHeight}, speed);
    return false;
  };


  /**
   * Open popin from URL
   */

  var kwUrl = new URL(window.location.href)
      urlParam = kwUrl.searchParams.get("back");
  
  if (urlParam == "12p") {
    $(".kw-body").addClass('kw-back-button');
  };

  var anchorArray = $(".kw-popin").map(function() {
    return $(this).attr("id");
  });
  var anchorUrlExist = ($.inArray(anchorURL, anchorArray) != -1);

  if (anchorUrlExist) {
    var targetedPopin = $("#" + anchorURL);
    $("#" + anchorURL).addClass('is-active');
    $("body").addClass('kw-popin-active');
    $("#page").addClass('kw-page-height-fixed');
    // Init slider
    slider = $("#" + anchorURL + " .kw-slider").slick({
        swipe:true,
        draggable: true,
        dots: true,
        responsive: [
          {
            breakpoint: 750,
            settings: {
              dots: false
            }
          }
        ]
    });
    // Init ranges' tooltips.
    if ($(targetedPopin).find(".kw-shiny-form").length !== 0) {
      $(".kw-shiny-form__range").each(function() {
        setTooltip($(this));
      });
    };
    // Set "Perfect-Scrollbar".
    if (mediumScreen) {
      var scrollBlock = document.getElementsByClassName("kw-slider__item-text-scroll");
      for (var i = scrollBlock.length - 1; i >= 0; i--) {
        var ps = new PerfectScrollbar(scrollBlock[i]);
      };
    }
    // Set sticky menu
    stickyMenu();
    setTimeout(function(){
      $("html").addClass('header-sticky');
      $("#header").addClass('active');

      $("body").addClass("kw-js-scrolled");
      
    }, 500);
    console.log('open from url');
    $("#footer").addClass('kw-footer-hidden');
  };

  /**
   * Mini popin
   */

  var miniPopinItem = $(".kw-mini-popins__item")

  $(".kw-mini-popin-link__item").on("click", openMiniPopin);
  $(".kw-mini-popin__close-button").on("click", closeMiniPopin);

  function openMiniPopin(){
    var targetID = $($(this).attr("href"));
    miniPopinItem.removeClass("kw-is-active");
    targetID.addClass("kw-is-active");
  }

  function closeMiniPopin(){
    miniPopinItem.removeClass("kw-is-active");
  }

  /**
   * Meteo
   */
  if($(".kw-index-uv__infos").length){
    var appID = 'a41de3c160b6c38f82bcb3ac83c6fbac',
        statsDisplay = {};

    if(navigator.geolocation) {

      // Get stats and stock them in object
      function getStats(lat,lng) {
        $.getJSON("https://api.openweathermap.org/data/2.5/weather?lat="+lat+"&lon="+lng+"&units=metric&APPID="+appID+"&callback=?",function(result){
            statsDisplay.temperature = result.main.temp;
            statsDisplay.town = result.name;
            statsDisplay.weather = result.weather;
            $.getJSON("https://api.openweathermap.org/data/2.5/uvi?appid="+appID+"&lat="+lat+"&lon="+lng, function(result) {
              statsDisplay.uv = Math.round(result.value);
              displayStats();
            });

        });
      }

      // Display stats from object
      function displayStats() {
        // $("#meteo").append('INDEX UV '+statsDisplay.uv+' | '+statsDisplay.temperature +'&deg; C | '+statsDisplay.town);
        $(".kw-index-uv__link span").text(statsDisplay.uv);
        $(".kw-index-uv__infos").text( Math.ceil(statsDisplay.temperature) +'°C | '+statsDisplay.town);
        $(".kw-index-uv__infos").addClass("kw-icon--" + statsDisplay.weather[0].icon);
      }

      // Callback function in case of success
      function affichePosition(position) {
        getStats(position.coords.latitude, position.coords.longitude)
      }

      // Callback function in case of fail
      function erreurPosition(error) {
        switch(error.code) {
          case error.TIMEOUT:
            console.log("TIMEOUT");
          break;
          case error.PERMISSION_DENIED:
            console.log("PERMISSION DENIED");
          break;
          case error.POSITION_UNAVAILABLE:
            console.log("POSITION UNAVAILABLE");
          break;
          case error.UNKNOWN_ERROR:
            console.log("UNKNOWN ERROR");
          break;
        }
        document.getElementById("kw-meteo").innerHTML = info;
      }

      navigator.geolocation.getCurrentPosition(affichePosition,erreurPosition);

    } else {
      document.getElementById("kw-meteo").innerHTML = "Ce navigateur ne supporte pas la géolocalisation";
    } 
  }


  /**
   * Quizz
   */

  $(".kw-quizz__button").on("click", quizzAnswer);
  $(".kw-answer__button").on("click", nextQuestion);

  function quizzAnswer(e){
    e.preventDefault();
    var parentSlide = $(this).parents(".kw-slider__item");
    if ($(this).val() == 1) {
      parentSlide.removeClass("kw-slider__item--wrong-answer");
      parentSlide.addClass("kw-slider__item--right-answer");
    } else {
      parentSlide.removeClass("kw-slider__item--right-answer");
      parentSlide.addClass("kw-slider__item--wrong-answer");
    }
  }

  function nextQuestion(){
    $(".slick-slider").slick("slickNext");
  }


  /**
   * Facebook
   */

  $(".kw-share-link").on("click", fbShare);

  function fbShare(e) {
    e.preventDefault();
    u = location.href.split('?')[0];
    window.open('http://www.facebook.com/sharer.php?u='+encodeURIComponent(u),'sharer','toolbar=0,status=0,width=626,height=436');
    return false;
  }

  /**
   *  Internal popin link fix
   */


  // $(".kw-slider__item-text a").click(function(e) {
  //   e.preventDefault();
  //   location.href = $(this).attr('href');
  //   console.log(location.href);
  //   setTimeout(function(){ document.location.reload(true); }, 500);
  // });
  

});